package ch.zhaw.projekt2.turnierverwaltung.main.tournamentList;

import ch.zhaw.projekt2.turnierverwaltung.FXController;
import ch.zhaw.projekt2.turnierverwaltung.FileIO;
import ch.zhaw.projekt2.turnierverwaltung.InvalidNameException;
import ch.zhaw.projekt2.turnierverwaltung.Tournament;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.*;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.GridPane;

import java.io.File;
import java.io.IOException;

public class TournamentListController extends FXController {

    @FXML
    public void initialize(){
        modusChoiceBox.setItems(Tournament.Type.getObservableList());
    }

    @FXML
    private Button createBtn;


    @FXML
    private ChoiceBox<Tournament.Type> modusChoiceBox;

    @FXML
    private Label newTournamentFormularTitle;

    @FXML
    private Button openBtn;

    @FXML
    private Button deleteBtn;

    @FXML
    private Label tournamentListTitle;

    @FXML
    private ListView<FileIO.TournamentFile> tournamentListView;

    @FXML
    private Label tournamentModLabel;

    @FXML
    private Label tournamentNameLabel;

    @FXML
    private TextField tournamentNameField;

    @Override
    public void shareGUIElementWithLanguageConfigurator() {
        getLanguageConfigurator().recieveLabel(createBtn);
        getLanguageConfigurator().recieveLabel(newTournamentFormularTitle);
        getLanguageConfigurator().recieveLabel(openBtn);
        getLanguageConfigurator().recieveLabel(deleteBtn);
        getLanguageConfigurator().recieveLabel(tournamentListTitle);
        getLanguageConfigurator().recieveLabel(tournamentModLabel);
        getLanguageConfigurator().recieveLabel(tournamentNameLabel);
    }

    @FXML
    void createTournament(ActionEvent event) {
        getTournamentDecorator().createTournament(tournamentNameField.getText(), modusChoiceBox.getValue());
    }

    @FXML
    void openTournament(ActionEvent event) {
        FileIO.TournamentFile tournamentFile = tournamentListView.getSelectionModel().getSelectedItems().get(0);
        getFactoryDecorator().openTournament(tournamentFile);
    }

    @FXML
    void deleteTournament(ActionEvent event) {
        FileIO.TournamentFile tournamentFile = tournamentListView.getSelectionModel().getSelectedItems().get(0);
        AlertDelete alert = new AlertDelete(getLanguageConfigurator());
        if(alert.showAndGetResult()){
           getTournamentDecorator().deleteTournament(tournamentFile);
        }
    }

    @Override
    public void loadContent() {
        tournamentListView.setItems(getFileIO().getList());
        tournamentNameField.clear();
    }
}

