package ch.zhaw.projekt2.turnierverwaltung;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class PlayerTest {
    private Player player;

    @Test
    @DisplayName("Test invalid Parameter")
    void invalidParams() {
        try {
            assertThrows(Person.InvalidPhoneNumberException.class,()->new Player("A","a",".sad",""));
            assertThrows(Player.InvalidDateException.class,()->new Player("A","a","","a"));
            player = new Player("A","A","","");
            assertEquals("A",player.getFirstName());
            assertEquals("A",player.getName());
            assertEquals("",player.getPhoneNumber());
            assertNull(player.getDateOfBirth());
        } catch (InvalidNameException | Person.InvalidPhoneNumberException | Player.InvalidDateException e) {
            fail();
        }
    }

    @Test
    @DisplayName("Test equals")
    void equalsTest() {
        try {
            player = new Player("A","A","","");
            assertTrue(player.equals(player));
            assertFalse(player.equals(new Player("B", "D", "", "")));
            assertTrue(player.equals(new Player("A", "A", "", "")));
        } catch (InvalidNameException | Person.InvalidPhoneNumberException | Player.InvalidDateException e) {
            e.printStackTrace();
        }
    }
}
